<?php
/**
* CompileStyle: Plugin for MyPHPCommander
* Copyright (C) 2005-2006  Martin Schrder
* Compiles new Styles
*
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program;
* if not, see http://www.gnu.org/licenses/gpl.html
**/


class PluginCompileStyle extends PluginBase
{
  function PluginCompileStyle()
  {
    $this->pluginpath=dirname(__FILE__);
    $this->pluginpathhtml='plugins/CompileStyle/';
    $this->reqRight=0;
    $this->libs=array('CompileStyle');
    $this->fullname=$this->name='CompileStyle';
    $this->icon_big='compilestyle_big.png';
    $this->icon_small='compilestyle_small.png';
    $this->LoadLanguageTable();
  }

  function OutpBody()
  {
    if(!$this->DispatchActions())
      $this->ActionSetStyle();
  }

  function ActionSetStyle()
  {
    echo '<h2>'.$this->GetLanguageExpression('setstyle').'</h2>';

    echo '<form action="index.php?CompileStyle[action]=CompileStyle" method="post">';
    echo '<table class="noborder">';
    echo '<tr>';
    echo '<td>'.$this->GetLanguageExpression('stylename').'</td>';
    echo '<td><input type="text" name="stylename"/></td>';
    echo '</tr>';
    echo '</table>';
    echo '<input type="submit" value="'.$this->GetLanguageExpression('compile').'"/>';
    echo '</form>';
  }

  function ActionCompileStyle()
  {
    $compileStyle=new CCompileStyle;

    echo $this->GetLanguageExpression('compiling').'<br/>';
    $compileStyle->SetStyle($_REQUEST['stylename']);
    $errors=$compileStyle->Compile();
    if($errors!=0)
    {
      printf($this->GetLanguageExpression('errorsoccured'),$errors);
    }
    else
      echo $this->GetLanguageExpression('fullsuccess');
  }
}
?>
