<?php
/**
* Filemanager: Plugin for MyPHPCommander
* Copyright (C) 2005-2006  Martin Schrder
* Gives you the possibility to browse folders on the server, download or zip files
*
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program;
* if not, see http://www.gnu.org/licenses/gpl.html
**/


class PluginFilemanager extends PluginBase
{
  var $root;
  function PluginFilemanager()
  {
    $this->pluginpath=dirname(__FILE__);
    $this->pluginpathhtml='plugins/Filemanager/';
    $this->reqRight=1;
    $this->libs=array('mime','filesystem','dZip','dUnzip2');
    $this->fullname=$this->name='Filemanager';
    $this->icon_big='file-manager_big.png';
    $this->icon_small='file-manager_small.png';

    $this->LoadLanguageTable();

    if(!isset($_SESSION['Filemanager']['aktpath']))
      $_SESSION['Filemanager']['aktpath']=$this->GetConfigValue('root')?$this->GenerateGoodPath($this->GetConfigValue('root')):$this->GenerateGoodPath('./');
    else if(isset($_GET['Filemanager']['path']))
      $_SESSION['Filemanager']['aktpath']=$this->GenerateGoodPath($_GET['Filemanager']['path']);


    if(!isset($_SESSION['Filemanager']['clipboard']))
      $_SESSION['Filemanager']['clipboard']=array();

    //Give File if requested, then die
    if(isset($_REQUEST['Filemanager']['getfile']))
    {
      $filename=$_SESSION['Filemanager']['aktpath'].'/'.$_REQUEST['Filemanager']['getfile'];
      header('Content-type: '.$this->GetMimeType($filename));
      header('Content-Length: '.filesize($filename));
			header('Content-disposition: attachment; filename="'.$_REQUEST['Filemanager']['getfile'].'"');
      readfile($filename);
      die();
    }

    //Copy to clipboard
    if(isset($_REQUEST['Filemanager']['addtoclipboard_s']))
    {
      $addtoclipboard=unserialize($_REQUEST['Filemanager']['addtoclipboard_s']);
      foreach($addtoclipboard as $entry)
      {
        $entry_a=array('type'=>'file', 'content'=>$_SESSION['Filemanager']['aktpath'].$entry);
        if(!in_array($entry_a,$_SESSION['Filemanager']['clipboard']))
          $_SESSION['Filemanager']['clipboard'][]=$entry_a;
      }
    }

    //Remove from Clipboard
    if(isset($_REQUEST['Filemanager']['delete_ClipboardEntryID']))
    {
      if(isset($_SESSION['Filemanager']['clipboard'][$_REQUEST['Filemanager']['delete_ClipboardEntryID']]))
        unset($_SESSION['Filemanager']['clipboard'][$_REQUEST['Filemanager']['delete_ClipboardEntryID']]);
    }

    if($configroot=$this->GetConfigValue('root'))
    {
      $this->root=$this->GenerateGoodPath($configroot);
    }
    else
    {
      $this->root=$this->GetRoot($_SESSION['Filemanager']['aktpath']);
    }
  }

  /*****************************************************************************
  *** Output *******************************************************************
  *****************************************************************************/
  function OutpBody()
  {
    if(!$this->DispatchActions())
      $this->ActionShowFilesystem();
  }

  function OutpHeader()
  {
    echo '<style type="text/css">';
    echo 'div.titem { margin: 0px; padding-left: 0px; padding-top: 3px; margin-left: 10px; border-left: 1px solid #222222; white-space: nowrap; }';
    echo 'div.icon { margin: 2px; padding: 0px; float: left; width: 100px; height: 100px; overflow: hidden; text-align: center;}';
    echo 'div.icon a { text-decoration: none;}';
    echo 'option.clipbord_file:before { content:url(icons/file.png)" "; }';
    echo 'option.clipbord_noentry{ font-style: italic; }';
    echo '</style>';
  }

  function OutpMenu()
  {
    echo '<form action="index.php">';

    //Clipbord
    echo '<div style="float: right;">';
    echo '<select size=2 style="width: 300px">';
    if(empty($_SESSION['Filemanager']['clipboard']))
    {
      echo '<option value="" class="clipbord_noentry">'.$this->GetLanguageExpression('noentry').'</option>';
    }
    else
      foreach($_SESSION['Filemanager']['clipboard'] as $key => $entry)
      {
        if($entry['type']=='file')
          echo
          '<option value="'.$key.'" '.
          'class="clipbord_file" '.
          'ondblclick="location.href=\'index.php?Filemanager[action]=ShowClipboardEntry&amp;Filemanager[clipbordentryid]='.$key.'\'" '.
          'title="'.htmlentities($entry['content']).'">'.
          htmlentities('...'.substr($entry['content'],-30,30)).
          '</option>';
      }
    echo '</select>';
    echo '</div>';

    echo '<input type="text" name="Filemanager[path]" style="width: 500px;" value="'.htmlentities($_SESSION['Filemanager']['aktpath']).'"/><input type="submit" value="Go!"/>';
    echo '<br/>';
    //Up
    echo '<a href="index.php?Filemanager[path]='.rawurlencode(realpath($_SESSION['Filemanager']['aktpath'].'/..')).'"><img src="icons/up.png" alt="'.$this->GetLanguageExpression('up').'"/>'.$this->GetLanguageExpression('up').'</a> ';
    //Delete
    echo '<a onclick="if(!confirm(\''.addslashes($this->GetLanguageExpression('really_delete')).'\')) return false; var marked=GetMarked(\'files\'); if(marked.length<1) {alert(\''.addslashes($this->GetLanguageExpression('nofilesmarked')).'\'); return false;} var serializer = new PHP_Serializer(); document.location.href=\'index.php?Filemanager[action]=DeleteFile&amp;Filemanager[filenames_s]=\'+serializer.serialize(marked); return false;" href="index.php"><img src="icons/remove.png" alt="'.$this->GetLanguageExpression('remove').'"/>'.$this->GetLanguageExpression('remove').'</a> ';
    //New Folder
    echo '<a href="index.php?Filemanager[action]=CreateFolder"><img src="icons/folder_new.png" alt="'.$this->GetLanguageExpression('newfolder').'"/>'.$this->GetLanguageExpression('newfolder').'</a> ';
    //Zip
    echo '<a onclick="var marked=GetMarked(\'files\'); if(marked.length<1) {alert(\''.addslashes($this->GetLanguageExpression('nofilesmarked')).'\'); return false;} var serializer = new PHP_Serializer(); document.location.href=\'index.php?Filemanager[action]=ZipFile&amp;Filemanager[filenames_s]=\'+serializer.serialize(marked); return false;" href="index.php"><img src="icons/compress.png" alt="'.$this->GetLanguageExpression('zip').'"/>'.$this->GetLanguageExpression('zip').'</a> ';

    //Add to clipboard
    echo '<a onclick="var marked=GetMarked(\'files\'); if(marked.length<1) {alert(\''.addslashes($this->GetLanguageExpression('nofilesmarked')).'\'); return false;} var serializer = new PHP_Serializer(); document.location.href=\'index.php?Filemanager[addtoclipboard_s]=\'+serializer.serialize(marked); return false;" href="index.php"><img src="icons/editcopy.png" alt="'.$this->GetLanguageExpression('copytoclipboard').'"/>'.$this->GetLanguageExpression('copytoclipboard').'</a> ';

    echo '</form>';
  }

  /*****************************************************************************
  *** Actions ******************************************************************
  *****************************************************************************/
  function ActionShowFilesystem()
  {
    //Tree view
    $dirlist=$this->MakeDirList($_SESSION['Filemanager']['aktpath']);
    echo '<div style="float: left; width: 250px; border-right: 1px solid black; overflow: auto; height: 421px;" class="plugin_subarea">';
    echo '<div style="white-space: nowrap"><a href="index.php?Filemanager[path]='.$this->root.'"><img src="icons/filemanager/folder.png" alt=""/>'.$this->root.'</a></div>';
    $this->DrawTree($this->root,$dirlist);
    echo '</div>';

    //Folder view
    echo '<div style="overflow: auto; height: 421px;"  class="plugin_subarea">';
    $files=array();
    $folders=array();
    $handle=@opendir($_SESSION['Filemanager']['aktpath'].'/');
    if(!$handle)
    {
      echo 'Error';
    }
    else
    {
      while (($file = readdir($handle)) !==false)
      {
        if(is_file($_SESSION['Filemanager']['aktpath'].'/'.$file))
        {
          $files[]=$file;
        }
        else if(is_dir($_SESSION['Filemanager']['aktpath'].'/'.$file) && $file!='.' && $file!='..')
        {
          $folders[]=$file;
        }
      }
      closedir($handle);
    }

    natcasesort($files);
    natcasesort($folders);

    echo '<form name="files" action="index.php">';
    foreach($folders as $folder)
    {
      $this->DrawFolderIcon($_SESSION['Filemanager']['aktpath'].$folder,$folder);
    }

    foreach($files as $file)
    {
      $this->DrawFileIcon($file);
    }
    echo '</form>';
    echo '</div>';
  }

  function ActionShowFile()
  {
    echo '<h1>'.$this->GetLanguageExpression('showfile').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i>';
    echo '<table class="noborder">';
    echo '<tr>';
    echo '<td><b>'.$this->GetLanguageExpression('filename').':</b></td>';
    echo '<td>'.$_REQUEST['Filemanager']['filename'].'</td>';
    echo '</tr>';
    echo '<tr>';

    $mimetype=$this->GetMimeType($_REQUEST['Filemanager']['filename']);

    echo '<tr>';
    echo '<td><b>'.$this->GetLanguageExpression('mimetype').':</b></td>';
    echo '<td>'.$mimetype.'</td>';
    echo '</tr>';

    list($major,$minor)=explode('/',$mimetype,2);

    switch($major)
    {
    case 'application':
      switch($minor)
      {
      //Unzip
      case 'zip':
        echo '<tr>';
        echo '<td>&nbsp;</td>';
        echo '<td><a href="index.php?Filemanager[action]=UnzipFile&Filemanager[file]='.htmlentities(rawurlencode($_REQUEST['Filemanager']['filename'])).'">'.$this->GetLanguageExpression('unziphere').'</a></td>';
        echo '</tr>';
        break;
      }
      break;
    //Show Text
    case 'text':
      echo '<tr>';
      echo '<td>&nbsp;</td>';
      echo '<td><a href="index.php?LoadPlugin=Notepad&Notepad[action]=ShowFile&Notepad[file]='.htmlentities(rawurlencode($_REQUEST['Filemanager']['filename'])).'">'.$this->GetLanguageExpression('notepad').'</a></td>';
      echo '</tr>';
      break;
    }

    echo '<tr>';
    echo '<td>&nbsp;</td>';
    echo '<td><a href="index.php?Filemanager[getfile]='.htmlentities(rawurlencode($_REQUEST['Filemanager']['filename'])).'">'.$this->GetLanguageExpression('download').'</a></td>';
    echo '</tr>';
    echo '</table>';
  }

  function ActionUnzipFile()
  {
    echo '<h1>'.$this->GetLanguageExpression('unziphere').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i>';

    $file=$_SESSION['Filemanager']['aktpath'].$_REQUEST['Filemanager']['file'];

    $unzip=new dUnzip2($file);
    $unzip->unzipAll($_SESSION['Filemanager']['aktpath']);
  }

  function ActionDeleteFile()
  {
    echo '<h1>'.$this->GetLanguageExpression('deletefile').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i><br/>';

    //$_REQUEST['Filemanager']['filenames_s']=rawurldecode($_REQUEST['Filemanager']['filenames_s']);

    if(!$filenames=unserialize($_REQUEST['Filemanager']['filenames_s']))
    {
      echo $_REQUEST['Filemanager']['filenames_s'];
      return;
    }
    echo '<table class="noborder">';
    foreach($filenames as $filename)
    {
      echo '<tr>';
      echo '<td>'.$filename.'</td>';
      $suc=RemoveEx($_SESSION['Filemanager']['aktpath'].'/'.$filename);
      echo '<td><i>'.($suc?$this->GetLanguageExpression('delete_success'):$this->GetLanguageExpression('delete_error')).'</i></td>';
      echo '</tr>';
    }
    echo '</table>';
  }

  function ActionZipFile()
  {
    echo '<h1>'.$this->GetLanguageExpression('compressfile').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i><br/>';

    if(!$filenames=unserialize($_REQUEST['Filemanager']['filenames_s']))
    {
      echo $_REQUEST['Filemanager']['filenames_s'];
      return;
    }

    if(count($filenames)==1)
      $archname=$filenames[0];
    else
      $archname=basename($_SESSION['Filemanager']['aktpath']);

    $archname.='.zip';

    echo $archname;

    $zip=new dZip($_SESSION['Filemanager']['aktpath'].$archname);

    $error=false;

    echo '<table class="noborder">';
    foreach($filenames as $filename)
    {
      echo '<tr>';
      echo '<td>'.$filename.'</td>';
      $suc=$this->AddDirToZip($_SESSION['Filemanager']['aktpath'],$filename,$zip);
      echo '<td><i>'.($suc?$this->GetLanguageExpression('zip_success'):$this->GetLanguageExpression('zip_error')).'</i></td>';
      echo '</tr>';
    }
    echo '</table>';

    $zip->save();
  }

  function ActionCreateFolder()
  {
    echo '<div class="plugin_subarea">';
    echo '<h1>'.$this->GetLanguageExpression('newfolder').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i><br/>';
    if(isset($_REQUEST['Filemanager']['foldername']))
    {
      if(mkdir($_SESSION['Filemanager']['aktpath'].$_REQUEST['Filemanager']['foldername']))
        echo $this->GetLanguageExpression('foldercreate_success');
      else
        echo $this->GetLanguageExpression('foldercreate_error');
    }
    else
    {
      echo '<form action="index.php?Filemanager[action]=CreateFolder" method="post">';
      echo '<table border="0">';
      echo '<tr>';
      echo '<td>'.$this->GetLanguageExpression('name').'</td>';
      echo '<td><input type="text" name="Filemanager[foldername]" /></td>';
      echo '</tr>';
      echo '</table>';
      echo '<input type="submit" value="'.$this->GetLanguageExpression('create').'" />';
      echo '</form>';
    }
    echo '</div>';
  }

  function ActionShowClipboardEntry()
  {
    echo '<div class="plugin_subarea">';
    echo '<h1>'.$this->GetLanguageExpression('showclipboardentry').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i><br/>';

    $entry=$_SESSION['Filemanager']['clipboard'][$_REQUEST['Filemanager']['clipbordentryid']];

    if(!$entry)
    {
      return;
    }

    echo '<table border="0">';
    echo '<tr>';
    echo '<th>'.$this->GetLanguageExpression('type').'</th>';
    echo '<td>'.($entry['type']=='file'?$this->GetLanguageExpression('file'):$this->GetLanguageExpression('other')).'</td>';
    echo '</tr>';
    echo '<tr>';
    echo '<th>'.$this->GetLanguageExpression('content').'</th>';
    echo '<td>'.htmlentities($entry['content']).'</td>';
    echo '</tr>';
    echo '</table>';

    echo '<p>';
    echo '<b>'.$this->GetLanguageExpression('actions').'</b><br/>';
    echo '<a href="index.php?Filemanager[delete_ClipboardEntryID]='.$_REQUEST['Filemanager']['clipbordentryid'].'"><img src="icons/remove.png" alt=""/> '.$this->GetLanguageExpression('removeclipboardentry').'</a><br/>';
    if($entry['type']=='file')
    {
      echo '<a href="index.php?Filemanager[action]=CopyFile&amp;Filemanager[clipbordentryid]='.$_REQUEST['Filemanager']['clipbordentryid'].'"><img src="icons/editcopy.png" alt=""/> '.$this->GetLanguageExpression('copyhere').'</a><br/>';
      echo '<a href="index.php?Filemanager[action]=MoveFile&amp;Filemanager[clipbordentryid]='.$_REQUEST['Filemanager']['clipbordentryid'].'"><img src="icons/editmove.png" alt=""/> '.$this->GetLanguageExpression('movehere').'</a><br/>';
    }
    echo '</p>';

    echo '</div>';
  }

  function ActionCopyFile()
  {
    echo '<div class="plugin_subarea">';
    echo '<h1>'.$this->GetLanguageExpression('copyhere').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i><br/>';

    if(CopyRecoursive($_SESSION['Filemanager']['clipboard'][$_REQUEST['Filemanager']['clipbordentryid']]['content'],$_SESSION['Filemanager']['aktpath']))
      echo $this->GetLanguageExpression('copyfile_success');
    else
      echo $this->GetLanguageExpression('copyfile_error');

    echo '</div>';
  }

  function ActionMoveFile()
  {
    echo '<div class="plugin_subarea">';
    echo '<h1>'.$this->GetLanguageExpression('movehere').'</h1>';
    echo '<i><a href="index.php">'.$this->GetLanguageExpression('back').'</a></i><br/>';

    if(MoveRecoursive($_SESSION['Filemanager']['clipboard'][$_REQUEST['Filemanager']['clipbordentryid']]['content'],$_SESSION['Filemanager']['aktpath']))
      echo $this->GetLanguageExpression('movefile_success');
    else
      echo $this->GetLanguageExpression('movefile_error');

    unset($_SESSION['Filemanager']['clipboard'][$_REQUEST['Filemanager']['clipbordentryid']]);

    echo '</div>';
  }

  /*****************************************************************************
  *** Help functions ***********************************************************
  *****************************************************************************/
  function AddDirToZip($basedir,$file,&$zip,$zipdir='')
  {
    if(is_file($basedir.$file))
      return $zip->addFile($basedir.$file,$zipdir.$file);

    $success=true;
    if(is_dir($basedir.$file))
    {
      $zip->addDir($zipdir.$file.'/');
      $handle=opendir($basedir.$file);
      while($aktfile=readdir($handle))
      {
        if(($aktfile!='.') && ($aktfile!='..'))
          $success&=$this->AddDirToZip($basedir.$file.'/',$aktfile,$zip,$zipdir.$file.'/');
      }
      closedir($handle);
      return $success;
    }
    return false;
  }

  function GetRoot($path)
  {
    $list=split('[/\]',$path,2);
    return $this->GenerateGoodPath($list[0]);
  }

  function MakeDirList($directory)
  {
    $root=$this->GetRoot($directory);
    $windows=strlen($root)>1;
    if($windows)
    {
      list($drive,$directory)=explode(':', $directory);
      $dirlist=split('[/\]',$directory);
      $dirs[0]=$drive.':';
      $i=1;
      unset($dirlist[0]);
      foreach($dirlist as $dir)
      {
        $dirs[$i]=$dirs[$i-1].'/'.$dir;
        $i++;
      }
    }
    else
    {
      $dirlist=split('[/\]',$directory);
      $dirs[0]='';
      $i=1;
      unset($dirlist[0]);
      foreach($dirlist as $dir)
      {
        $dirs[$i]=$dirs[$i-1].'/'.$dir;
        $i++;
      }
    }
    return $dirs;
  }

  function DrawTree($dir, $dirs)
  {
    unset($dirs[array_search($dir,$dirs)]);
    sort($dirs);

    if((!$this->IsAccessableDir($dir))||(!$handle=@opendir($dir)))
    {
      if(count($dirs)>0)
      {
        $dirnames=explode('/',$dirs[0]);
        $dirname=$dirnames[count($dirnames)-1];
        echo '<div class="titem">-  <a href="index.php?Filemanager[path]='.rawurlencode($dir.$dirname).'"><img src="icons/folder_small_open.png" alt=""/>'.$dirname.'</a>';
        $this->DrawTree($dir.$dirname.'/',$dirs);
        echo '</div>';
        echo "\n";
      }
    }
    else
    {
      while (($file = readdir($handle)) !==false)
      {
        if(is_dir($dir.$file)&&$file!='.'&&$file!='..')
        {
          $isAccessable=$this->IsAccessableDir($dir.$file);
          $displayedName=htmlentities($file).($isAccessable?'':' <b>[!]</b>');
          if(($key=array_search($dir.$file,$dirs))!==false)
          {
            echo '<div class="titem">-  <a href="index.php?Filemanager[path]='.rawurlencode($dir.$file).'"><img src="icons/folder_small_open'.($isAccessable?'':'_restricted').'.png" alt=""/>'.$displayedName.'</a>';
            $this->DrawTree($dirs[$key].'/',$dirs);
            echo '</div>';
          }
          else
          {
            echo '<div class="titem">-  <a href="index.php?'.(empty($inherit_argsGet)?'':$inherit_argsGet.'&').'Filemanager[path]='.rawurlencode($dir.$file).'"><img src="icons/'.($isAccessable?'folder_small':'folder_small_restricted').'.png" alt=""/>'.$displayedName.'</a></div>';
            echo "\n";
          }
        }
      }
      closedir($handle);
    }
  }

  function DrawFolderIcon($path, $name)
  {
    echo '<div class="icon">';
    echo '<input type="checkbox" name="'.htmlentities($name).'"/>';
    echo '<a href="index.php?Filemanager[path]='.htmlentities(rawurlencode($path)).'"><img src="icons/fileicons/folder.png" alt=""/><br/>'.nl2br(htmlentities(wordwrap($name,9,"\n",true))).'</a>';
    echo '</div>';
  }

  function DrawFileIcon($name)
  {
    echo '<div class="icon">';
    echo '<input type="checkbox" name="'.htmlentities($name).'"/>';
    echo '<a href="index.php?Filemanager[filename]='.htmlentities(rawurlencode($name)).'&amp;Filemanager[action]=ShowFile"><img src="icons/fileicons/'.$this->GetFileIcon($name).'" alt=""/><br/>'.nl2br(htmlentities(wordwrap($name,9,"\n",true))).'</a>';
    echo '</div>';
  }

  function GetFileIcon($filename)
  {
    global $mime_images;
    $ext=strtolower(substr(strrchr($filename, '.'), 1));
    return (isset($mime_images[$ext])?$mime_images[$ext]:'unknown').'.png';
  }

  function GetMimeType($filename)
  {
    global $mime_types;
    $ext=strtolower(substr(strrchr($filename, '.'), 1));
    return (isset($mime_types[$ext])?$mime_types[$ext]:'application/octet-stream');
  }

  function GenerateGoodFilename($fn)
  {
    return str_replace(array('','','','','',''),array('ae','oe','ue','Ae','Oe','Ue'),$fn);
  }

  function GenerateGoodPath($path)
  {
    return str_replace(array('\\','//'),'/',realpath($path).'/');
  }

  function IsAccessableDir($path)
  {
    return @is_readable($path.'/.');
  }
}
?>
