<?php
/**
* Login: Plugin for MyPHPCommander
* Copyright (C) 2005-2006  Martin Schrder
* Gives you the possibility to log in as a specific user.
* Needs the "user"-library.
*
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program;
* if not, see http://www.gnu.org/licenses/gpl.html
**/


class PluginLogin extends PluginBase
{
  function PluginLogin()
  {
    $this->pluginpath=dirname(__FILE__);
    $this->pluginpathhtml='plugins/Login/';
    $this->reqRight=0;
    $this->libs=array('user');
    $this->fullname=$this->name='Login';
    $this->icon_big='login_big.png';
    $this->icon_small='login_small.png';
    $this->LoadLanguageTable();
  }

  function OutpBody()
  {
    global $gl_current_user;

    echo '<div style="overflow: auto;" class="plugin_subarea">';

    $this->DispatchActions();

    if(isset($gl_current_user->data['info']['is_anonymous']) && ($gl_current_user->data['info']['is_anonymous']==1))
    {
      echo $this->GetLanguageExpression('not_logged_in').'<br/>';
      echo $this->GetLanguageExpression('log_in');

      echo '<form action="index.php?Login[action]=Login" method="post"/>';
      echo '<table border=0>';
      echo '<tr>';
      echo '<td>'.$this->GetLanguageExpression('name').'</td>';
      echo '<td><input type="text" name="Login[name]"/></td>';
      echo '</tr>';
      echo '<tr>';
      echo '<td>'.$this->GetLanguageExpression('password').'</td>';
      echo '<td><input type="password" name="Login[password]"/></td>';
      echo '</tr>';
      echo '</table>';
      echo '<input type="submit" value="'.$this->GetLanguageExpression('login').'"/>';
      echo '</form>';
    }
    else
    {
      echo '<table border=0>';
      echo '<tr>';
      echo '<th>'.$this->GetLanguageExpression('name').'</th>';
      echo '<td>'.$gl_current_user->data['info']['name'].'</td>';
      echo '</tr>';
      echo '</table>';
      echo '<a href="index.php?Login[action]=Logout">'.$this->GetLanguageExpression('logout').'</a>';
    }

    echo '</div>';
  }

  function ActionLogin()
  {
    global $gl_current_user;
    if($gl_current_user->LogIn($_REQUEST['Login']['name'],$_REQUEST['Login']['password']))
      echo $this->GetLanguageExpression('login_success');
    else
      echo $this->GetLanguageExpression('login_error');
    echo '<br/>';
  }

  function ActionLogout()
  {
    global $gl_current_user;
    $gl_current_user->LogOut();
  }
}
?>
