<?php
/**
* MyPHPCommander: The management tool
* Copyright (C) 2005-2006  Martin Schrder
*
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program;
* if not, see http://www.gnu.org/licenses/gpl.html
**/

class PluginBase
{
  var $pluginpath, $pluginpathhtml;
  var $icon_small, $icon_big;
  var $reqRight;
  var $name, $fullname;
  var $libs;
  var $LanguageTable;

  /*****************************************************************************
  * Intern *********************************************************************
  *****************************************************************************/
  function DispatchActions($allow='')
  {
    $found=false;
    if(isset($_REQUEST[$this->name]['action']))
    {
      if(is_array($_REQUEST[$this->name]['action']))
      {
        foreach($_REQUEST[$this->name]['action'] as $actionname)
        {
          $found|=$this->_callAction($actionname,$allow);
        }
      }
      else
      {
        $found|=$this->_callAction($_REQUEST[$this->name]['action'],$allow);
      }
    }
    return $found;
  }

  function _callAction($name,$allow)
  {
    if((empty($allow)||in_array($name,$allow)) && is_callable(array($this, 'Action'.$name)))
    {
      call_user_func(array(&$this, 'Action'.$name));
      return true;
    }
    return false;
  }

  function GetLanguageExpression($key)
  {
    global $gl_language;
    if(isset($this->LanguageTable[$key]))
      return $this->LanguageTable[$key];
    if(isset($gl_language[$key]))
      return $gl_language[$key];
    return '['.$key.']';
  }

  function LoadLanguageTable()
  {
    global $gl_config;
    $pluginLanguageTable=
    $this->LanguageTable=@parse_ini_file($this->pluginpath.'/'.$gl_config['general']['language'].'.lng');
  }

  function LoadConfiguration()
  {
  }

  function GetConfigValue($name)
  {
    global $gl_current_user;
    if(isset($gl_current_user->data['programs'][strtolower($this->name)][$name]))
      return $gl_current_user->data['programs'][strtolower($this->name)][$name];

    return false;
  }

  /*****************************************************************************
  * Output *********************************************************************
  *****************************************************************************/
  function OutpFirst()
  {
  }

  function OutpHeader()
  {
  }

  function OutpBody()
  {
  }

  function OutpMenu()
  {
  }

  function OutpJSData()
  {
  }
}
?>
