<?php
/**
* MyPHPCommander: The management tool
* Copyright (C) 2005-2006  Martin Schrder

* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your option)
* any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program;
* if not, see http://www.gnu.org/licenses/gpl.html
**/

/*******************************************************************************
* Plugin operations ************************************************************
*******************************************************************************/
function LoadPlugin($plugin)
{
  if(!in_array($plugin,$_SESSION['LoadedPlugins']))
    $_SESSION['LoadedPlugins'][]=$plugin;
}

function UnloadPlugin($plugin)
{
  global $gl_LoadedPluginsObjects;
  if(($key=array_search($plugin,$_SESSION['LoadedPlugins']))!==false)
  {
    unset($_SESSION['LoadedPlugins'][$key]);
    if(isset($gl_LoadedPluginsObjects[$key]))
    {
      unset($gl_LoadedPluginsObjects[$key]);
    }
    return true;
  }
  return false;
}

//Menfunktionen
function DrawMenuIconRight($name,$img,$link,$onclick='')
{
  echo '<div class="menuicon" style="float: right;"><a href="'.$link.'" onclick="'.$onclick.'"><img src="'.$img.'"/><br>'.$name.'</a></div>';
}

function DrawMenuIcon($name,$img,$link,$onclick='')
{
  echo '<div class="menuicon"><a href="'.$link.'" onclick="'.$onclick.'"><img src="'.$img.'"/>'.$name.'</a></div>';
}

function DrawMenuIconWithSubPage($name,$img,$subpage, $onclick='')
{
  $id=str_replace(array(' ','&'),'_',strtolower($name));
  echo '<div class="menuicon"><a href="" onclick="';
  echo $onclick;
  echo ' ShowHideSubmenuSubpage(\''.$id.'\', this.offsetLeft, this.offsetTop+30);';
  echo ' return false;"><img src="'.$img.'"/><br>'.$name.'</a></div>';
  echo '<div id="'.$id.'" class="smsp">'.$subpage.'</div>';
}

function JsShowSubmenuSubpage()
{
  ?>
  <script type="text/javascript">
  var ids=new Array();
  function ShowHideSubmenuSubpage(id,x,y)
  {
    var subpage=document.getElementById(id);
    if(ids[id]==1)
    {
      subpage.style.top ="-1000px";
      subpage.style.left="-1000px";
      ids[id]=0;
    }
    else
    {
      subpage.style.top =y+"px";
      subpage.style.left=x+"px";
      ids[id]=1;
    }
  }
  function GetMarked()
  {
    formobj=document.forms['form'];
    var i;
    var marked=new Array();
    for(i=0;i<formobj.elements.length;i++)
    {
      if(formobj.elements[i].checked==true)
      {
        marked.push(formobj.elements[i].name);
      }
    }
    return marked;
  }
  </script>
  <?php
}

function GetExtension($filename)
{
  return substr(strrchr($filename, '.'), 1);
}

function GetMimeType($ext)
{
  global $mime_types;
  $ext=strtolower($ext);
  if(isset($mime_types[$ext]))
    return $mime_types[$ext];
  return 'application/unknown';
}

function TempFilename($prefix='tmp')
{
  return 'temp/'.$prefix.'_'.time().'.tmp';
}

function AddConsoleEntry($type,$text)
{
  $_SESSION['ConsoleEntries'][]=array('type'=>$type,'text'=>$text);
}
?>
