<?php
/**
* MyPHPCommander: The management tool
* Copyright (C) 2005-2006  Martin Schrder

* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your option)
* any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program;
* if not, see http://www.gnu.org/licenses/gpl.html
**/

class CCompileStyle
{
  var $style;

  function SetStyle($style)
  {
    $this->style=$style;
  }

  function Compile()
  {
    global $gl_root;
    $errors=0;

    include $gl_root.'styles/'.$this->style.'/stylesheet.php';

    $output="/*This file is autogenerated, please don't change!*/\n";

    $output.="/*HTML-Elements*/\n";
    foreach($DPelements['elements'] as $name => $prop)
    {
      $output.=$name.' { ';
      foreach($prop as $pname => $pvalue)
      {
        $output.=$pname.': '.$pvalue.'; ';
      }
      $output.="}\n";
    }

    $output.="/*IDs*/\n";
    foreach($DPelements['ids'] as $name => $prop)
    {
      $output.='#'.$name.' { ';
      foreach($prop as $pname => $pvalue)
      {
        $output.=$pname.': '.$pvalue.'; ';
      }
      $output.="}\n";
    }

    $output.="/*Classes*/\n";
    foreach($DPelements['classes'] as $name => $prop)
    {
      $output.='.'.$name.' { ';
      foreach($prop as $pname => $pvalue)
      {
        $output.=$pname.': '.$pvalue.'; ';
      }
      $output.="}\n";
    }

    $filename=$gl_root.'styles/compiled.css';
    file_put_contents($filename,$output);

    return $errors;
  }

  //Help functions
  function HexToArray($string,$transparency)
  {
    $values=str_split(substr($string,1),2);
    for($i=0;isset($values[$i]);$i++)
      $values[$i]=hexdec($values[$i]);
    $values=array_merge($values,array($transparency));
    return ($values);
  }
}
?>
