<?php
function RemoveEx($filearg)
{
  if(is_dir($filearg))
  {
    $handle=opendir($filearg);
    while (($file = readdir($handle)) !==false)
    {
      if(($file!='.') && ($file!='..'))
        RemoveEx($filearg.'/'.$file);
    }
    closedir($handle);
    if(!rmdir($filearg))
    {
      return false;
    }
  }
  else if(is_file($filearg))
  {
    if(!unlink($filearg))
    {
      return false;
    }
  }
  else
  {
      return false;
  }
  return true;
}

function MakeDirectory($dir, $mode = 0755)
{
  if (is_dir($dir) || @mkdir($dir,$mode)) return TRUE;
  if (!MakeDirectory(dirname($dir),$mode)) return FALSE;
  return @mkdir($dir,$mode);
}

function CopyRecoursive($source, $destination)
{
  if(is_dir($source)&&is_dir($destination))
  {
    $noerr=true;
    $handle=opendir($source);
    if(!$handle)
      return false;
    $destination=$destination.'/'.basename($source);
    if(!MakeDirectory($destination))
      return false;
    while($file=readdir($handle))
    {
      if($file!='.' && $file!='..')
        $noerr&=CopyRecoursive($source.'/'.$file,$destination);
    }
    closedir($handle);
    return $noerr;
  }
  else if(is_file($source)&&is_dir($destination))
  {
    return copy($source,$destination.'/'.basename($source));
  }
  else if(is_file($source)&&is_file($destination))
  {
    return copy($source,$destination);
  }
  return false;
}

function MoveRecoursive($source, $destination)
{
  if(is_dir($source)&&is_dir($destination))
  {
    $noerr=true;
    $handle=opendir($source);
    if(!$handle)
      return false;
    $destination=$destination.'/'.basename($source);
    if(!MakeDirectory($destination))
      return false;
    while($file=readdir($handle))
    {
      if($file!='.' && $file!='..')
        $noerr&=MoveRecoursive($source.'/'.$file,$destination);
    }
    closedir($handle);

    RemoveEx($source);

    return $noerr;
  }
  else if(is_file($source)&&is_dir($destination))
  {
    return rename($source,$destination.'/'.basename($source));
  }
  else if(is_file($source)&&is_file($destination))
  {
    return rename($source,$destination);
  }
  return false;
}
?>
