<?php
function http_get($url)
{

   $url_stuff = parse_url($url);
   $port = isset($url_stuff['port']) ? $url_stuff['port'] : 80;

   $fp = fsockopen($url_stuff['host'], $port);

   $query  = 'GET ' . $url_stuff['path'] . " HTTP/1.0\n";
   $query .= 'Host: ' . $url_stuff['host'];
   $query .= "\n\n";

   fwrite($fp, $query);

  $buffer='';
   while ($tmp = fread($fp, 1024))
   {
       $buffer .= $tmp;
   }

   preg_match('/Content-Length: ([0-9]+)/', $buffer, $parts);
   return substr($buffer, - $parts[1]);
}

function write_ini_file($path, $assoc_array)
{
   $content = '';
   $sections = '';

   foreach ($assoc_array as $key => $item)
   {
       if (is_array($item))
       {
           $sections .= "\n[{$key}]\n";
           foreach ($item as $key2 => $item2)
           {
               if (is_numeric($item2) || is_bool($item2))
                   $sections .= "{$key2} = {$item2}\n";
               else
                   $sections .= "{$key2} = \"{$item2}\"\n";
           }
       }
       else
       {
           if(is_numeric($item) || is_bool($item))
               $content .= "{$key} = {$item}\n";
           else
               $content .= "{$key} = \"{$item}\"\n";
       }
   }

   $content .= $sections;

   if (!$handle = fopen($path, 'w'))
   {
       return false;
   }

   if (!fwrite($handle, $content))
   {
       return false;
   }

   fclose($handle);
   return true;
}

class INIFile
{
  var $data;
  var $valid;
  var $errstack;

  function INIFile($file)
  {
    $this->valid=false;

    if(strncmp($file,'http://',6)==0)
    {
      //HTTP
      $contents=http_get($file);

      $tmpfname = TempFilename ('ini');
      $handle = fopen($tmpfname, 'w');
      fwrite($handle, $contents);
      fclose($handle);
      @$this->data=parse_ini_file($tmpfname,true);
      if($this->data)
        unlink($tmpfname);
      else
      {
        $this->errstack.='File Error parsing '.$tmpfname.'. URL: '.$file.'<br>';
        return;
      }
    }
    else
    {
      $this->data=parse_ini_file($file,true);
    }
    $this->valid=true;
  }

  function isValid()
  {
    return $this->valid;
  }

  function Save($filename)
  {
    $content = '';
    $sections = '';

    foreach ($this->data as $key => $item)
    {
       if (is_array($item))
       {
           $sections .= "\n[{$key}]\n";
           foreach ($item as $key2 => $item2)
           {
               if (is_numeric($item2) || is_bool($item2))
                   $sections .= "{$key2} = {$item2}\n";
               else
                   $sections .= "{$key2} = \"{$item2}\"\n";
           }
       }
       else
       {
           if(is_numeric($item) || is_bool($item))
               $content .= "{$key} = {$item}\n";
           else
               $content .= "{$key} = \"{$item}\"\n";
       }
    }

    $content .= $sections;

    if (!$handle = fopen($path, 'w'))
    {
       return false;
    }

    if (!fwrite($handle, $content))
    {
       return false;
    }

    fclose($handle);
    return true;
  }
};
?>
