<?php
$i=0;
define('CXML2_NODETYPE_TEXT',$i++);
define('CXML2_NODETYPE_ELEMENT',$i++);

class CXML2
{
  var $root;
  var $filename;
  var $ptrCurrentElement;
  var $xmlParser;

  function Read($filename)
  {
    $this->filename=$filename;

    $this->xmlParser = xml_parser_create();
    xml_set_object($this->xmlParser, $this);

    xml_set_element_handler($this->xmlParser, '_TagOpen', '_TagClose');
    xml_set_character_data_handler($this->xmlParser, '_CData');

    $this->ptrCurrentElement=&$this->root;
    $this->root=new CXML2_Node;
    $this->root->type=CXML2_NODETYPE_ELEMENT;
    $this->root->parent=0;

    return $this->_parse($filename);
  }

  /*****************************************************************************
  *** HELP FUNCTIONS ***********************************************************
  *****************************************************************************/
  function _parse($xml_file)
  {
    if (!(@$fp = fopen($xml_file, 'r')))
      return false;

    $bytes_to_parse = 512;

    while ($data = fread($fp, $bytes_to_parse))
    {
      $parse = xml_parse($this->xmlParser, $data, feof($fp));

      if (!$parse)
      {
        echo sprintf("XML error: %s at line %d",
        xml_error_string(xml_get_error_code($this->xmlParser)),
        xml_get_current_line_number($this->xmlParser));
        return false;
      }
    }
    return true;
  }

  /*****************************************************************************
  *** Handlers *****************************************************************
  *****************************************************************************/
  function _TagOpen($parser, $name, $attributes)
  {
    $this->ptrCurrentElement=$this->ptrCurrentElement->AddChild(CXML2_NODETYPE_ELEMENT);
    $this->ptrCurrentElement->name=strtolower($name);
    $this->ptrCurrentElement->attributes=$this->ArrayKeyToLower($attributes);
  }

  function _CData($parser, $cdata)
  {
    $cdata=trim($cdata);
    if(!empty($cdata))
    {
      $node=&$this->ptrCurrentElement->AddChild(CXML2_NODETYPE_TEXT);
      $node->cdata=$cdata;
    }
  }

  function _TagClose($parser, $name)
  {
    $this->ptrCurrentElement=$this->ptrCurrentElement->parent;
  }

  /*****************************************************************************
  *** Help Functions ***********************************************************
  *****************************************************************************/
  function ArrayKeyToLower($array)
  {
    $newarray=array();
    foreach($array as $key => $entry)
      $newarray[strtolower($key)]=$entry;
    return $newarray;
  }
};

class CXML2_Node
{
  var $childs, $parent;

  var $name, $type, $attributes, $cdata;

  function &GetChildsByType($type)
  {
    $childs=array();
    foreach($this->childs as &$child)
    {
      if($child->type==$type)
        $childs[]=&$child;
    }
    return $childs;
  }

  function &GetChildsByName($name)
  {
    $childs=array();
    foreach($this->childs as &$child)
    {
      if($child->name==$name)
        $childs[]=&$child;
    }
    return $childs;
  }

  function &GetFirstChildByName($name)
  {
    foreach($this->childs as &$child)
    {
      if($child->name==$name)
        return $child;
    }
    return false;
  }

  function GetAttribute($name)
  {
    return $this->attributes[$name];
  }

  function &AddChild($type)
  {
    $child=new CXML2_Node;
    $child->type=$type;
    $child->parent=$this;

    $this->childs[]=&$child;

    return $child;
  }
};
?>
