<?php
/**
 *   This file is part of MyPHPCommander.
 *
 *  MyPHPCommander is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MyPHPCommander is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MyPHPCommander; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
define('RightExec',1);
define('RightWrite',2);
define('RightRead',4);

function GetFileRights($file)
{
  $rights=isset($_SESSION['user']['rights']['filesystem'][RealPathEx($file)])?$_SESSION['user']['rights']['filesystem'][RealPathEx($file)]:$_SESSION['user']['rights']['filesystem']['__all'];
  return $rights;
}

function MayDoFileOperation($file,$operation)
{
  return GetFileRights($file) & $operation;
}

function MayOpenProgram($program)
{
  $right=isset($_SESSION['user']['rights']['programs'][$program])?$_SESSION['user']['rights']['programs'][$program]:$_SESSION['user']['rights']['programs']['__all'];
  return $right;
}

function IsLoggedIn()
{
  $loggedin=false;
  do
  {
    if(!isset($_SESSION['login']))
      break;
    if(!$_SESSION['login'])
      break;
    if($_SESSION['ip']!=$_SERVER["REMOTE_ADDR"])
      break;
    $loggedin=true;
  } while(false);
  return $loggedin;
}

function MakeRWX($right)
{
  $read=0;
  $write=0;
  $exec=0;

  if($right>=RightRead)
  {
    $read=true;
    $right-=RightRead;
  }
  if($right>=RightWrite)
  {
    $write=true;
    $right-=RightWrite;
  }
  if($right>=RightExec)
  {
    $exec=true;
    $right-=RightExec;
  }
  return ($read?'r':'-').($write?'w':'-').($exec?'x':'-');
}

function MayAccessDir($dir)
{
  if(@file_exists($dir.'/.'))
  {
    $handle=@opendir($dir);
    if(!$handle)
      return false;
    closedir($handle);
    return true;
  }
  return false;
}

function MakeRWXFromRealPermission($right)
{
  $right=decoct($right);
  $string='';

  $right=substr($right,2);

  for($i=0;$i<3;$i++)
  {
    $r=substr($right,0,1);

    if($r>=RightRead)
    {
      $string.='r';
      $r-=RightRead;
    }
    else
    {
      $string.='-';
    }
    if($r>=RightWrite)
    {
      $string.='w';
      $r-=RightWrite;
    }
    else
    {
      $string.='-';
    }
    if($r>=RightExec)
    {
      $string.='x';
      $r-=RightExec;
    }
    else
    {
      $string.='-';
    }

    $right=substr($right,1);
    $string.=' ';
  }

  return $string;
}

function ParseRWX($string)
{
  $right=0;
  $read=strpos(strtolower($string),'r');
  $write=strpos(strtolower($string),'w');
  $exec=strpos(strtolower($string),'x');
  if($read !== false)
    $right|=RightRead;
  if($write !== false)
    $right|=RightWrite;
  if($exec !== false)
    $right|=RightExec;
  return $right;
}
?>
